import Tpl from "./template.js";
import { Handler } from "./types.js";
export default class Router {
    private routes;
    private tpl?;
    private mimes;
    constructor();
    importRoutesFromPath(p: string, tpl?: Tpl | false): Promise<this>;
    group(basePath: string | RegExp, callback: (methods: any) => void): this;
    private combinePaths;
    use(obj: Router | Tpl): void;
    get(path: string | RegExp, ...callback: Handler[]): this;
    post(path: string | RegExp, ...callback: Handler[]): this;
    head(path: string | RegExp, ...callback: Handler[]): this;
    put(path: string | RegExp, ...callback: Handler[]): this;
    delete(path: string | RegExp, ...callback: Handler[]): this;
    patch(path: string | RegExp, ...callback: Handler[]): this;
    private registerRoute;
    getRoute(path: string, method: string): any;
    private sortRoutes;
    private readMimes;
    static({ dir, route }: {
        dir?: string;
        route?: RegExp;
    }): this;
}
